Index: drivers/filesystems/btrfs/write.c
===================================================================
--- drivers/filesystems/btrfs/write.c	(révision 74430)
+++ drivers/filesystems/btrfs/write.c	(copie de travail)
@@ -3292,51 +3700,34 @@
         
         remove_fcb_extent(fcb, ext, rollback);
     } else if (start_data <= ext->offset && end_data < ext->offset + ed2->num_bytes) { // replace beginning
-        EXTENT_DATA *ned, *nedb;
         EXTENT_DATA2* ned2;
         extent *newext1, *newext2;
         
-        ned = ExAllocatePoolWithTag(PagedPool, ext->datalen, ALLOC_TAG);
-        if (!ned) {
-            ERR("out of memory\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
-        
-        nedb = ExAllocatePoolWithTag(PagedPool, ext->datalen, ALLOC_TAG);
-        if (!nedb) {
-            ERR("out of memory\n");
-            ExFreePool(ned);
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
-        
-        newext1 = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
+        newext1 = ExAllocatePoolWithTag(PagedPool, offsetof(extent, extent_data) + ext->datalen, ALLOC_TAG);
         if (!newext1) {
             ERR("out of memory\n");
-            ExFreePool(ned);
-            ExFreePool(nedb);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
         
-        newext2 = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
+        newext2 = ExAllocatePoolWithTag(PagedPool, offsetof(extent, extent_data) + ext->datalen, ALLOC_TAG);
         if (!newext2) {
             ERR("out of memory\n");
-            ExFreePool(ned);
-            ExFreePool(nedb);
             ExFreePool(newext1);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
         
-        RtlCopyMemory(ned, ext->data, ext->datalen);
-        ned->type = EXTENT_TYPE_REGULAR;
-        ned2 = (EXTENT_DATA2*)ned->data;
+        RtlCopyMemory(&newext1->extent_data, &ext->extent_data, ext->datalen);
+        newext1->extent_data.type = EXTENT_TYPE_REGULAR;
+        ned2 = (EXTENT_DATA2*)newext1->extent_data.data;
         ned2->num_bytes = end_data - ext->offset;
         
-        RtlCopyMemory(nedb, ext->data, ext->datalen);
-        ned2 = (EXTENT_DATA2*)nedb->data;
+        RtlCopyMemory(&newext2->extent_data, &ext->extent_data, ext->datalen);
+        ned2 = (EXTENT_DATA2*)newext2->extent_data.data;
         ned2->offset += end_data - ext->offset;
         ned2->num_bytes -= end_data - ext->offset;
         
-        Status = write_data_complete(fcb->Vcb, ed2->address + ed2->offset, (UINT8*)data + ext->offset - start_data, end_data - ext->offset, Irp, NULL);
+        Status = write_data_complete(fcb->Vcb, ed2->address + ed2->offset, (UINT8*)data + ext->offset - start_data, end_data - ext->offset,
+                                     Irp, NULL, file_write, irp_offset + ext->offset - start_data);
         if (!NT_SUCCESS(Status)) {
             ERR("write_data_complete returned %08x\n", Status);
             return Status;
@@ -3348,8 +3739,6 @@
             
             if (!csum) {
                 ERR("out of memory\n");
-                ExFreePool(ned);
-                ExFreePool(nedb);
                 ExFreePool(newext1);
                 ExFreePool(newext2);
                 return STATUS_INSUFFICIENT_RESOURCES;
@@ -3358,8 +3747,6 @@
             Status = calc_csum(fcb->Vcb, (UINT8*)data + ext->offset - start_data, sl, csum);
             if (!NT_SUCCESS(Status)) {
                 ERR("calc_csum returned %08x\n", Status);
-                ExFreePool(ned);
-                ExFreePool(nedb);
                 ExFreePool(newext1);
                 ExFreePool(newext2);
                 ExFreePool(csum);
@@ -3373,7 +3760,6 @@
         *written = end_data - ext->offset;
         
         newext1->offset = ext->offset;
-        newext1->data = ned;
         newext1->datalen = ext->datalen;
         newext1->unique = ext->unique;
         newext1->ignore = FALSE;
@@ -3383,7 +3769,6 @@
         add_insert_extent_rollback(rollback, fcb, newext1);
         
         newext2->offset = end_data;
-        newext2->data = nedb;
         newext2->datalen = ext->datalen;
         newext2->unique = ext->unique;
         newext2->ignore = FALSE;
@@ -3409,53 +3794,35 @@
 
         remove_fcb_extent(fcb, ext, rollback);
     } else if (start_data > ext->offset && end_data >= ext->offset + ed2->num_bytes) { // replace end
-        EXTENT_DATA *ned, *nedb;
         EXTENT_DATA2* ned2;
         extent *newext1, *newext2;
         
-        ned = ExAllocatePoolWithTag(PagedPool, ext->datalen, ALLOC_TAG);
-        if (!ned) {
-            ERR("out of memory\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
-        
-        nedb = ExAllocatePoolWithTag(PagedPool, ext->datalen, ALLOC_TAG);
-        if (!nedb) {
-            ERR("out of memory\n");
-            ExFreePool(ned);
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
-        
-        newext1 = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
+        newext1 = ExAllocatePoolWithTag(PagedPool, offsetof(extent, extent_data) + ext->datalen, ALLOC_TAG);
         if (!newext1) {
             ERR("out of memory\n");
-            ExFreePool(ned);
-            ExFreePool(nedb);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
         
-        newext2 = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
+        newext2 = ExAllocatePoolWithTag(PagedPool, offsetof(extent, extent_data) + ext->datalen, ALLOC_TAG);
         if (!newext2) {
             ERR("out of memory\n");
-            ExFreePool(ned);
-            ExFreePool(nedb);
             ExFreePool(newext1);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
         
-        RtlCopyMemory(ned, ext->data, ext->datalen);
+        RtlCopyMemory(&newext1->extent_data, &ext->extent_data, ext->datalen);
         
-        ned2 = (EXTENT_DATA2*)ned->data;
+        ned2 = (EXTENT_DATA2*)newext1->extent_data.data;
         ned2->num_bytes = start_data - ext->offset;
         
-        RtlCopyMemory(nedb, ext->data, ext->datalen);
+        RtlCopyMemory(&newext2->extent_data, &ext->extent_data, ext->datalen);
         
-        nedb->type = EXTENT_TYPE_REGULAR;
-        ned2 = (EXTENT_DATA2*)nedb->data;
+        newext2->extent_data.type = EXTENT_TYPE_REGULAR;
+        ned2 = (EXTENT_DATA2*)newext2->extent_data.data;
         ned2->offset += start_data - ext->offset;
         ned2->num_bytes = ext->offset + ed2->num_bytes - start_data;
         
-        Status = write_data_complete(fcb->Vcb, ed2->address + ned2->offset, data, ned2->num_bytes, Irp, NULL);
+        Status = write_data_complete(fcb->Vcb, ed2->address + ned2->offset, data, ned2->num_bytes, Irp, NULL, file_write, irp_offset);
         if (!NT_SUCCESS(Status)) {
             ERR("write_data_complete returned %08x\n", Status);
             return Status;
@@ -3467,8 +3834,6 @@
             
             if (!csum) {
                 ERR("out of memory\n");
-                ExFreePool(ned);
-                ExFreePool(nedb);
                 ExFreePool(newext1);
                 ExFreePool(newext2);
                 return STATUS_INSUFFICIENT_RESOURCES;
@@ -3477,8 +3842,6 @@
             Status = calc_csum(fcb->Vcb, data, sl, csum);
             if (!NT_SUCCESS(Status)) {
                 ERR("calc_csum returned %08x\n", Status);
-                ExFreePool(ned);
-                ExFreePool(nedb);
                 ExFreePool(newext1);
                 ExFreePool(newext2);
                 ExFreePool(csum);
@@ -3492,7 +3855,6 @@
         *written = ned2->num_bytes;
         
         newext1->offset = ext->offset;
-        newext1->data = ned;
         newext1->datalen = ext->datalen;
         newext1->unique = ext->unique;
         newext1->ignore = FALSE;
@@ -3503,7 +3865,6 @@
         add_insert_extent_rollback(rollback, fcb, newext1);
         
         newext2->offset = start_data;
-        newext2->data = nedb;
         newext2->datalen = ext->datalen;
         newext2->unique = ext->unique;
         newext2->ignore = FALSE;
@@ -3528,79 +3889,48 @@
 
         remove_fcb_extent(fcb, ext, rollback);
     } else if (start_data > ext->offset && end_data < ext->offset + ed2->num_bytes) { // replace middle
-        EXTENT_DATA *ned, *nedb, *nedc;
         EXTENT_DATA2* ned2;
         extent *newext1, *newext2, *newext3;
         
-        ned = ExAllocatePoolWithTag(PagedPool, ext->datalen, ALLOC_TAG);
-        if (!ned) {
-            ERR("out of memory\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
-        
-        nedb = ExAllocatePoolWithTag(PagedPool, ext->datalen, ALLOC_TAG);
-        if (!nedb) {
-            ERR("out of memory\n");
-            ExFreePool(ned);
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
-        
-        nedc = ExAllocatePoolWithTag(PagedPool, ext->datalen, ALLOC_TAG);
-        if (!nedb) {
-            ERR("out of memory\n");
-            ExFreePool(ned);
-            ExFreePool(nedb);
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
-        
-        newext1 = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
+        newext1 = ExAllocatePoolWithTag(PagedPool, offsetof(extent, extent_data) + ext->datalen, ALLOC_TAG);
         if (!newext1) {
             ERR("out of memory\n");
-            ExFreePool(ned);
-            ExFreePool(nedb);
-            ExFreePool(nedc);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
         
-        newext2 = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
+        newext2 = ExAllocatePoolWithTag(PagedPool, offsetof(extent, extent_data) + ext->datalen, ALLOC_TAG);
         if (!newext2) {
             ERR("out of memory\n");
-            ExFreePool(ned);
-            ExFreePool(nedb);
-            ExFreePool(nedc);
             ExFreePool(newext1);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
         
-        newext3 = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
+        newext3 = ExAllocatePoolWithTag(PagedPool, offsetof(extent, extent_data) + ext->datalen, ALLOC_TAG);
         if (!newext2) {
             ERR("out of memory\n");
-            ExFreePool(ned);
-            ExFreePool(nedb);
-            ExFreePool(nedc);
             ExFreePool(newext1);
             ExFreePool(newext2);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
         
-        RtlCopyMemory(ned, ext->data, ext->datalen);
-        RtlCopyMemory(nedb, ext->data, ext->datalen);
-        RtlCopyMemory(nedc, ext->data, ext->datalen);
+        RtlCopyMemory(&newext1->extent_data, &ext->extent_data, ext->datalen);
+        RtlCopyMemory(&newext2->extent_data, &ext->extent_data, ext->datalen);
+        RtlCopyMemory(&newext3->extent_data, &ext->extent_data, ext->datalen);
         
-        ned2 = (EXTENT_DATA2*)ned->data;
+        ned2 = (EXTENT_DATA2*)newext1->extent_data.data;
         ned2->num_bytes = start_data - ext->offset;
         
-        nedb->type = EXTENT_TYPE_REGULAR;
-        ned2 = (EXTENT_DATA2*)nedb->data;
+        newext2->extent_data.type = EXTENT_TYPE_REGULAR;
+        ned2 = (EXTENT_DATA2*)newext2->extent_data.data;
         ned2->offset += start_data - ext->offset;
         ned2->num_bytes = end_data - start_data;
         
-        ned2 = (EXTENT_DATA2*)nedc->data;
+        ned2 = (EXTENT_DATA2*)newext3->extent_data.data;
         ned2->offset += end_data - ext->offset;
         ned2->num_bytes -= end_data - ext->offset;
         
-        ned2 = (EXTENT_DATA2*)nedb->data;
-        Status = write_data_complete(fcb->Vcb, ed2->address + ned2->offset, data, end_data - start_data, Irp, NULL);
+        ned2 = (EXTENT_DATA2*)newext2->extent_data.data;
+        Status = write_data_complete(fcb->Vcb, ed2->address + ned2->offset, data, end_data - start_data, Irp, NULL, file_write, irp_offset);
         if (!NT_SUCCESS(Status)) {
             ERR("write_data_complete returned %08x\n", Status);
             return Status;
@@ -3612,9 +3942,6 @@
             
             if (!csum) {
                 ERR("out of memory\n");
-                ExFreePool(ned);
-                ExFreePool(nedb);
-                ExFreePool(nedc);
                 ExFreePool(newext1);
                 ExFreePool(newext2);
                 ExFreePool(newext3);
@@ -3624,9 +3951,6 @@
             Status = calc_csum(fcb->Vcb, data, sl, csum);
             if (!NT_SUCCESS(Status)) {
                 ERR("calc_csum returned %08x\n", Status);
-                ExFreePool(ned);
-                ExFreePool(nedb);
-                ExFreePool(nedc);
                 ExFreePool(newext1);
                 ExFreePool(newext2);
                 ExFreePool(newext3);
@@ -3641,7 +3965,6 @@
         *written = end_data - start_data;
         
         newext1->offset = ext->offset;
-        newext1->data = ned;
         newext1->datalen = ext->datalen;
         newext1->unique = ext->unique;
         newext1->ignore = FALSE;
@@ -3652,7 +3975,6 @@
         add_insert_extent_rollback(rollback, fcb, newext1);
         
         newext2->offset = start_data;
-        newext2->data = nedb;
         newext2->datalen = ext->datalen;
         newext2->unique = ext->unique;
         newext2->ignore = FALSE;
@@ -3662,7 +3984,6 @@
         add_insert_extent_rollback(rollback, fcb, newext2);
         
         newext3->offset = end_data;
-        newext3->data = nedc;
         newext3->datalen = ext->datalen;
         newext3->unique = ext->unique;
         newext3->ignore = FALSE;
@@ -3692,7 +4013,7 @@
     return STATUS_SUCCESS;
 }
 
-NTSTATUS do_write_file(fcb* fcb, UINT64 start, UINT64 end_data, void* data, PIRP Irp, LIST_ENTRY* rollback) {
+NTSTATUS do_write_file(fcb* fcb, UINT64 start, UINT64 end_data, void* data, PIRP Irp, BOOL file_write, UINT32 irp_offset, LIST_ENTRY* rollback) {
     NTSTATUS Status;
     LIST_ENTRY *le, *le2;
     UINT64 written = 0, length = end_data - start;
@@ -3710,7 +4031,7 @@
         le2 = le->Flink;
         
         if (!ext->ignore) {
-            EXTENT_DATA* ed = ext->data;
+            EXTENT_DATA* ed = &ext->extent_data;
             EXTENT_DATA2* ed2 = ed->type == EXTENT_TYPE_INLINE ? NULL : (EXTENT_DATA2*)ed->data;
             UINT64 len;
             
@@ -3732,7 +4053,7 @@
                         return Status;
                     }
                     
-                    Status = insert_extent(fcb->Vcb, fcb, start_write, ext->offset - start_write, data, Irp, rollback);
+                    Status = insert_extent(fcb->Vcb, fcb, start_write, ext->offset - start_write, (UINT8*)data + written, Irp, file_write, irp_offset + written, rollback);
                     if (!NT_SUCCESS(Status)) {
                         ERR("insert_extent returned %08x\n", Status);
                         return Status;
@@ -3751,7 +4072,7 @@
                                     
                     TRACE("doing non-COW write to %llx\n", writeaddr);
                     
-                    Status = write_data_complete(fcb->Vcb, writeaddr, (UINT8*)data + written, write_len, Irp, NULL);
+                    Status = write_data_complete(fcb->Vcb, writeaddr, (UINT8*)data + written, write_len, Irp, NULL, file_write, irp_offset + written);
                     if (!NT_SUCCESS(Status)) {
                         ERR("write_data_complete returned %08x\n", Status);
                         return Status;
@@ -3774,7 +4095,7 @@
                     UINT64 write_len;
                     
                     Status = do_write_file_prealloc(fcb, ext, start + written, end_data, (UINT8*)data + written, &write_len,
-                                                    Irp, rollback);
+                                                    Irp, file_write, irp_offset + written, rollback);
                     if (!NT_SUCCESS(Status)) {
                         ERR("do_write_file_prealloc returned %08x\n", Status);
                         return Status;
@@ -3804,7 +4125,7 @@
             return Status;
         }
         
-        Status = insert_extent(fcb->Vcb, fcb, start_write, end_data - start_write, data, Irp, rollback);
+        Status = insert_extent(fcb->Vcb, fcb, start_write, end_data - start_write, (UINT8*)data + written, Irp, file_write, irp_offset + written, rollback);
         if (!NT_SUCCESS(Status)) {
             ERR("insert_extent returned %08x\n", Status);
             return Status;
@@ -3867,7 +4188,7 @@
             
             // write subsequent data non-compressed
             if (e2 < end_data) {
-                Status = do_write_file(fcb, e2, end_data, (UINT8*)data + e2, Irp, rollback);
+                Status = do_write_file(fcb, e2, end_data, (UINT8*)data + e2, Irp, FALSE, 0, rollback);
                 
                 if (!NT_SUCCESS(Status)) {
                     ERR("do_write_file returned %08x\n", Status);
@@ -3883,7 +4204,7 @@
 }
 
 NTSTATUS write_file2(device_extension* Vcb, PIRP Irp, LARGE_INTEGER offset, void* buf, ULONG* length, BOOL paging_io, BOOL no_cache,
-                     BOOL wait, BOOL deferred_write, LIST_ENTRY* rollback) {
+                     BOOL wait, BOOL deferred_write, BOOL write_irp, LIST_ENTRY* rollback) {
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     PFILE_OBJECT FileObject = IrpSp->FileObject;
     EXTENT_DATA* ed2;
@@ -4136,7 +4457,7 @@
         if (fileref)
             mark_fileref_dirty(fileref);
     } else {
-        BOOL compress = write_fcb_compressed(fcb);
+        BOOL compress = write_fcb_compressed(fcb), no_buf = FALSE;
         
         if (make_inline) {
             start_data = 0;
@@ -4156,36 +4477,41 @@
         fcb->Header.ValidDataLength.QuadPart = newlength;
         TRACE("fcb %p FileSize = %llx\n", fcb, fcb->Header.FileSize.QuadPart);
     
-        data = ExAllocatePoolWithTag(PagedPool, end_data - start_data + bufhead, ALLOC_TAG);
-        if (!data) {
-            ERR("out of memory\n");
-            Status = STATUS_INSUFFICIENT_RESOURCES;
-            goto end;
-        }
-        
-        RtlZeroMemory(data + bufhead, end_data - start_data);
-        
-        TRACE("start_data = %llx\n", start_data);
-        TRACE("end_data = %llx\n", end_data);
-        
-        if (offset.QuadPart > start_data || offset.QuadPart + *length < end_data) {
-            if (changed_length) {
-                if (fcb->inode_item.st_size > start_data) 
-                    Status = read_file(fcb, data + bufhead, start_data, fcb->inode_item.st_size - start_data, NULL, Irp, TRUE);
-                else
-                    Status = STATUS_SUCCESS;
-            } else
-                Status = read_file(fcb, data + bufhead, start_data, end_data - start_data, NULL, Irp, TRUE);
-            
-            if (!NT_SUCCESS(Status)) {
-                ERR("read_file returned %08x\n", Status);
-                ExFreePool(data);
+        if (!make_inline && !compress && offset.QuadPart == start_data && offset.QuadPart + *length == end_data) {
+            data = buf;
+            no_buf = TRUE;
+        } else {
+            data = ExAllocatePoolWithTag(PagedPool, end_data - start_data + bufhead, ALLOC_TAG);
+            if (!data) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
                 goto end;
             }
+            
+            RtlZeroMemory(data + bufhead, end_data - start_data);
+            
+            TRACE("start_data = %llx\n", start_data);
+            TRACE("end_data = %llx\n", end_data);
+            
+            if (offset.QuadPart > start_data || offset.QuadPart + *length < end_data) {
+                if (changed_length) {
+                    if (fcb->inode_item.st_size > start_data) 
+                        Status = read_file(fcb, data + bufhead, start_data, fcb->inode_item.st_size - start_data, NULL, Irp);
+                    else
+                        Status = STATUS_SUCCESS;
+                } else
+                    Status = read_file(fcb, data + bufhead, start_data, end_data - start_data, NULL, Irp);
+                
+                if (!NT_SUCCESS(Status)) {
+                    ERR("read_file returned %08x\n", Status);
+                    ExFreePool(data);
+                    goto end;
+                }
+            }
+            
+            RtlCopyMemory(data + bufhead + offset.QuadPart - start_data, buf, *length);
         }
         
-        RtlCopyMemory(data + bufhead + offset.QuadPart - start_data, buf, *length);
-        
         if (make_inline) {
             Status = excise_extents(fcb->Vcb, fcb, start_data, end_data, Irp, rollback);
             if (!NT_SUCCESS(Status)) {
@@ -4221,7 +4547,18 @@
             
             ExFreePool(data);
         } else {
-            Status = do_write_file(fcb, start_data, end_data, data, Irp, rollback);
+            if (write_irp && Irp->MdlAddress) {
+                BOOL locked = Irp->MdlAddress->MdlFlags & MDL_PAGES_LOCKED;
+                
+                if (!locked)
+                    MmProbeAndLockPages(Irp->MdlAddress, KernelMode, IoReadAccess);
+                
+                Status = do_write_file(fcb, start_data, end_data, data, Irp, TRUE, 0, rollback);
+                
+                if (!locked)
+                    MmUnlockPages(Irp->MdlAddress);
+            } else
+                Status = do_write_file(fcb, start_data, end_data, data, Irp, FALSE, 0, rollback);
             
             if (!NT_SUCCESS(Status)) {
                 ERR("do_write_file returned %08x\n", Status);
@@ -4229,7 +4566,8 @@
                 goto end;
             }
             
-            ExFreePool(data);
+            if (!no_buf)
+                ExFreePool(data);
         }
     }
     
@@ -4385,7 +4723,7 @@
     
 //     ERR("Irp->Flags = %x\n", Irp->Flags);
     Status = write_file2(Vcb, Irp, offset, buf, &IrpSp->Parameters.Write.Length, Irp->Flags & IRP_PAGING_IO, Irp->Flags & IRP_NOCACHE,
-                         wait, deferred_write, &rollback);
+                         wait, deferred_write, TRUE, &rollback);
     
     if (Status == STATUS_PENDING)
         goto exit;
@@ -4425,7 +4763,7 @@
 exit:
 //     if (locked) {
         if (NT_SUCCESS(Status))
-            clear_rollback(Vcb, &rollback);
+            clear_rollback(&rollback);
         else
             do_rollback(Vcb, &rollback);
 //         
@@ -4453,9 +4791,12 @@
 
     top_level = is_top_level(Irp);
     
-    if (Vcb && Vcb->type == VCB_TYPE_PARTITION0) {
-        Status = part0_passthrough(DeviceObject, Irp);
+    if (Vcb && Vcb->type == VCB_TYPE_VOLUME) {
+        Status = vol_write(DeviceObject, Irp);
         goto exit;
+    } else if (!Vcb || Vcb->type != VCB_TYPE_FS) {
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
     }
     
     if (!fcb) {
Index: sdk/include/ddk/ata.h
===================================================================
--- sdk/include/ddk/ata.h	(révision 74430)
+++ sdk/include/ddk/ata.h	(copie de travail)
@@ -252,6 +252,7 @@
 } IDENTIFY_DEVICE_DATA, *PIDENTIFY_DEVICE_DATA;
 #include <poppack.h>
 
-#define IDE_COMMAND_IDENTIFY 0xEC
+#define IDE_COMMAND_FLUSH_CACHE 0xE7
+#define IDE_COMMAND_IDENTIFY    0xEC
 
 #endif
Index: sdk/lib/wdmguid/wdmguid.c
===================================================================
--- sdk/lib/wdmguid/wdmguid.c	(révision 74430)
+++ sdk/lib/wdmguid/wdmguid.c	(copie de travail)
@@ -16,5 +16,9 @@
   0x53f56308L, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b);
 DEFINE_GUID(GUID_DEVINTERFACE_PARTITION,
   0x53f5630aL, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b);
+DEFINE_GUID(GUID_DEVINTERFACE_VOLUME,
+  0x53f5630dL, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b);
+DEFINE_GUID(GUID_DEVINTERFACE_HIDDEN_VOLUME,
+  0x7f108a28L, 0x9833, 0x4b3b, 0xb7, 0x80, 0x2c, 0x6b, 0x5f, 0xa5, 0xc0, 0x62);
 
 /* EOF */
